abuild.in 27.4 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2
#!/bin/sh

3
# script to build apk packages (light version of makepkg)
Natanael Copa's avatar
Natanael Copa committed
4 5 6 7 8 9 10
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11 12
abuild_ver=@VERSION@
sysconfdir=@sysconfdir@
13
abuildrepo=@abuildrepo@
Natanael Copa's avatar
Natanael Copa committed
14
datadir=@datadir@
Natanael Copa's avatar
Natanael Copa committed
15

16
program=${0##*/}
17
abuild_path=$(readlink -f $0)
Natanael Copa's avatar
Natanael Copa committed
18 19

# defaults
20
BUILD_BASE="build-base"
21
SUDO=${SUDO:-"sudo"}
22
FAKEROOT=${FAKEROOT:-"fakeroot"}
23
APK=${APK:-apk}
24

Natanael Copa's avatar
Natanael Copa committed
25
# read config
Natanael Copa's avatar
Natanael Copa committed
26
ABUILD_CONF=${ABUILD_CONF:-"$sysconfdir/abuild.conf"}
Natanael Copa's avatar
Natanael Copa committed
27 28
[ -f "$ABUILD_CONF" ] && . "$ABUILD_CONF"

29
default_colors() {
Natanael Copa's avatar
Natanael Copa committed
30 31 32 33 34 35
	NORMAL="\033[1;0m"
	STRONG="\033[1;1m"
	RED="\033[1;31m"
	GREEN="\033[1;32m"
	YELLOW="\033[1;33m"
	BLUE="\033[1;34m"
36 37 38 39 40 41 42 43 44 45 46 47 48 49
}

monochrome() {
	NORMAL=""
	STRONG=""
	RED=""
	GREEN=""
	YELLOW=""
	BLUE=""
}

#colors
if [ -n "$USE_COLORS" ]; then
    default_colors
Natanael Copa's avatar
Natanael Copa committed
50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73
fi	
	

# functions
msg() {
	local prompt="$GREEN>>>${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	[ -z "$quiet" ] && printf "${prompt} ${name}${fake}: $@\n" >&2
}

warning() {
	local prompt="${YELLOW}>>> WARNING:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}

error() {
	local prompt="${RED}>>> ERROR:${NORMAL}"
	local fake="${FAKEROOTKEY:+${BLUE}*${NORMAL}}"
	local name="${STRONG}${subpkgname:-$pkgname}${NORMAL}"
	printf "${prompt} ${name}${fake}: $@\n" >&2
}
74 75

	
Linux User's avatar
Linux User committed
76 77
set_xterm_title() {
	if [ "$TERM" = xterm ]; then
78
		 printf "\033]0;$1\007" >&2
Linux User's avatar
Linux User committed
79 80 81 82 83
	fi
} 

cleanup() {
	set_xterm_title ""
84
	if [ -z "$install_after" ] && [ -n "$uninstall_after" ]; then
85
		$SUDO $APK del $uninstall_after
86
	fi
Linux User's avatar
Linux User committed
87 88
}

Natanael Copa's avatar
Natanael Copa committed
89
die() {
Linux User's avatar
Linux User committed
90
	error "$@"
Linux User's avatar
Linux User committed
91
	cleanup
Natanael Copa's avatar
Natanael Copa committed
92 93 94
	exit 1
}

95 96
# check if apkbuild is basicly sane
sanitycheck() {
97
	local i suggestion
98
	msg "Checking sanity of $APKBUILD..."
99 100 101
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
102
	if [ "$pkgver" != "volatile" ] && [ -z "$nodeps" ]; then
103
		$APK version --check -q "$pkgver" ||\
104 105
			die "$pkgver is not a valid version"
	fi
106
	[ -z "$pkgrel" ] && die "Missing pkgrel in APKBUILD"
107 108 109 110
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

111 112 113 114 115 116 117 118 119 120
	# check if CARCH, CBUILD, CHOST and CTARGET is set
	if [ -z "$CARCH" ]; then
		case "$(uname -m)" in
		i[0-9]86) suggestion=" (Suggestion: CARCH=x86)";;
		x86_64) suggestion=" (Suggestion: CARCH=x86_64)";;
		esac
		die "Please set CARCH in /etc/abuild.conf$suggestion"
	fi
	[ -z "$CHOST" ] && die "Please set CHOST in /etc/abuild.conf"

Natanael Copa's avatar
Natanael Copa committed
121 122 123 124 125 126 127
	for i in $install; do
		[ -e "$startdir/$i" ] || die "install script $startdir/$i is missing"
	done
	
	[ -n "${triggers%%:*}" ] && [ ! -e "$startdir"/${triggers%%:*} ] \
		&& die "trigger script $startdir/${triggers%%:*} is missing"

128 129
	if [ -n "$source" ]; then
		for i in $source; do
Natanael Copa's avatar
Natanael Copa committed
130 131 132 133
			if install_has "$i"; then
				warning "You should not have \$install in source"
				continue
			fi
134
			md5sums_has ${i##*/} || die "${i##*/} is missing in md5sums"
135 136 137
			case "$i" in
				https://*) makedepends_has wget || die "wget must be in makedepends when source has https://" ;;
			esac
138 139
		done
	fi
Natanael Copa's avatar
Natanael Copa committed
140

141 142
	if [ -n "$md5sums" ]; then
		for i in $(echo "$md5sums" | awk '{ print $2 }'); do
Natanael Copa's avatar
Natanael Copa committed
143
			source_has $i || die "$i exists in md5sums but is missing in source"
144 145
		done
	fi
146

147 148 149
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"
Natanael Copa's avatar
Natanael Copa committed
150 151

	grep '^# Maintainer:' $APKBUILD >/dev/null || warning "No maintainer"
152 153

	makedepends_has 'g++' && warning "g++ should not be in makedepends"
154 155 156 157
	return 0
}

md5check() {
Natanael Copa's avatar
Natanael Copa committed
158
	local dummy f
159 160 161
	if [ -z "$source" ]; then
		return 0
	fi
162
	if [ -z "$md5sums" ]; then
163
		die "Use 'abuild checksum' to generate/update the checksum(s)"
164
	fi
165 166 167
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
168
	fetch || return 1
169
	msg "Checking md5sums..."
170
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
171 172 173 174
}

uri_fetch() {
	local uri="$1"
175
	local d="${uri##*/}"	# $(basename $uri)
176 177 178 179
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

180 181 182 183 184
	# we need GNU wget for this
	case "$uri" in
		https://*) opts="--no-check-certificate";;
	esac
	
Natanael Copa's avatar
Natanael Copa committed
185
	mkdir -p "$SRCDEST"
186 187 188
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
189
	fi
Linux User's avatar
Linux User committed
190
	msg "Fetching $uri"
191 192
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
193 194
}

195 196
is_remote() {
	case "$1" in
197
		http://*|ftp://*|https://*)
198 199 200 201 202
			return 0;;
	esac
	return 1
}

203 204 205 206 207
# try download from file from mirror first
uri_fetch_mirror() {
	local uri="$1"
	local d="${uri##*/}"	# $(basename $uri)
	if [ -n "$DISTFILES_MIRROR" ]; then
208 209 210 211 212
		if is_remote "$DISTFILES_MIRROR"; then
			uri_fetch "$DISTFILES_MIRROR"/$d && return 0
		else
			cp "$DISTFILES_MIRROR"/$d "$SRCDEST" && return 0
		fi
213 214 215 216
	fi
	uri_fetch "$uri"
}

217
default_fetch() {
Natanael Copa's avatar
Natanael Copa committed
218 219
	local s
	mkdir -p "$srcdir"
220 221
	for s in $source; do
		if is_remote "$s"; then
222
			uri_fetch_mirror "$s" || return 1
223 224 225 226
			ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
		else		
			ln -sf "$startdir/$s" "$srcdir/"
		fi
Natanael Copa's avatar
Natanael Copa committed
227 228 229
	done
}

230 231 232 233
fetch() {
	default_fetch
}

Natanael Copa's avatar
Natanael Copa committed
234
# unpack the sources
235
default_unpack() {
Natanael Copa's avatar
Natanael Copa committed
236
	local u
237
	md5check || return 1
Natanael Copa's avatar
Natanael Copa committed
238 239 240 241
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
242
			*.tar.gz|*.tgz)
243
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
244 245
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
246
				msg "Unpacking $s..."
Natanael Copa's avatar
Natanael Copa committed
247
				tar -C "$srcdir" -jxf "$s" || return 1;;
248 249 250 251
			*.tar.lzma)
				msg "Unpacking $s..."
				unlzma -c "$s" | tar -C "$srcdir" -x  \
					|| return 1;;
252 253 254
			*.tar.xz)
				msg "Unpacking $s..."
				unxz -c "$s" | tar -C "$srcdir" -x || return 1;;
Natanael Copa's avatar
Natanael Copa committed
255 256 257
			*.zip)
				msg "Unpacking $s..."
				unzip "$s" -d "$srcdir" || return 1;;
Natanael Copa's avatar
Natanael Copa committed
258 259 260 261
		esac
	done
}

262 263 264 265
unpack() {
	default_unpack
}

Natanael Copa's avatar
Natanael Copa committed
266 267
# cleanup source and package dir
clean() {
268
	msg "Cleaning temporary build dirs..."
Natanael Copa's avatar
Natanael Copa committed
269
	rm -rf "$srcdir"
270
	rm -rf "$pkgbasedir"
Natanael Copa's avatar
Natanael Copa committed
271 272 273 274 275 276
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
277 278 279 280
		if is_remote "$s"; then
			msg "Cleaning downloaded ${s##*/}..."
			rm -f "$SRCDEST/${s##*/}"
		fi
Natanael Copa's avatar
Natanael Copa committed
281 282 283 284 285
	done
}

cleanpkg() {
	local i
286
	getpkgver || return 1
287
	msg "Cleaning built packages..."
288
	for i in $pkgname $subpackages; do
289 290
		local p="${i%:*}-$pkgver-r$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz" \
291
			"$abuildrepo"/$p.apk
Natanael Copa's avatar
Natanael Copa committed
292
	done
293
	# remove given packages from index
Natanael Copa's avatar
Natanael Copa committed
294 295
}

296 297 298
# clean all packages except current
cleanoldpkg() {
	local i j
299
	getpkgver || return 1
300 301 302 303 304 305 306 307 308
	msg "Cleaning all packages except $pkgver-r$pkgrel..."
	for i in $pkgname $subpackages; do
		for j in "$PKGDEST"/${i%:*}-[0-9]*.apk; do
			[ "$j" != "$PKGDEST/${i%:*}-$pkgver-r$pkgrel.apk" ] \
				&& rm -f "$j"
		done
	done
	return 0
}
309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326

mkusers() {
	local i
	for i in $pkgusers; do
		if ! getent passwd $i >/dev/null; then
			msg "Creating user $i"
			$SUDO adduser -D -H $i || return 1
		fi
	done
	for i in $pkggroups; do
		if ! getent group $i >/dev/null; then
			msg "Creating group $i"
			$SUDO addgroup $i || return 1
		fi
	done
}


Natanael Copa's avatar
Natanael Copa committed
327 328
runpart() {
	local part=$1
329
	[ -n "$DEBUG" ] && msg "$part"
Natanael Copa's avatar
Natanael Copa committed
330 331 332 333
	$part || die "$part failed"
}

# override those in your build script
334 335 336 337 338 339 340 341
getpkgver() {
	# this func is supposed to be overridden by volatile packages
	if [ "$pkgver" = "volatile" ]; then
		error "Please provide a getpkgver() function in your APKBUILD"
		return 1
	fi
}

Natanael Copa's avatar
Natanael Copa committed
342 343 344 345
prepare() {
	:
}

Natanael Copa's avatar
Natanael Copa committed
346
build() {
347
	:
Natanael Copa's avatar
Natanael Copa committed
348 349
}

350 351 352 353 354 355
# generate a simple tar.gz package of pkgdir
targz() {
	cd "$pkgdir" || return 1
	tar -czf "$PKGDEST"/$pkgname-$pkgver-r$pkgrel.tar.gz *
}

356 357 358 359 360 361 362 363 364
get_split_func() {
	# get the 'func' from "sub-pkg:func"
	local func=${1##*:}

	# get 'func' from "sub-pkg-func" if there was no :func
	[ "$func" = "$1" ] && func=${func##*-}
	echo $func
}

365
prepare_subpackages() {
366
	if [ -z "$subpackages" ]; then
367 368
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
369 370
	local i
	cd "$startdir"
371
	for i in $subpackages; do
372 373
		local func=$(get_split_func $i)
		# call abuild recursively, setting subpkg{dir,name}
374
		msg "Running split function $func..."
375
		subpkgdir="$pkgbasedir/${i%:*}" subpkgname="${i%:*}" \
376
			$0 $func prepare_package || return 1
Natanael Copa's avatar
Natanael Copa committed
377 378 379
	done
}

380
prepare_metafiles() {
381
	getpkgver || return 1
382 383
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
384
	local dir=${subpkgdir:-$pkgdir}
385
	local pkg="$name-$pkgver-r$pkgrel.apk"
386
	local pkginfo="$controldir"/.PKGINFO
387
	local sub
Natanael Copa's avatar
Natanael Copa committed
388 389 390
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
391
	mkdir -p "$controldir"
Natanael Copa's avatar
Natanael Copa committed
392 393 394
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

395
	echo "# Generated by $(basename $0) $abuild_ver" >"$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
396
	if [ -n "$FAKEROOTKEY" ]; then
397
		echo "# using $($FAKEROOT -v)" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
398
	fi
399 400
	echo "# $(date -u)" >> "$pkginfo"
	cat >> "$pkginfo" <<EOF
401
pkgname = $name
402
pkgver = $pkgver-r$pkgrel
Natanael Copa's avatar
Natanael Copa committed
403 404 405 406 407 408
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
409 410
	local i deps
	deps="$depends"
411
	if [ "$pkgname" != "busybox" ] && ! depends_has busbox; then
Natanael Copa's avatar
Natanael Copa committed
412 413
		for i in $install ${triggers%%:*}; do
			if head -n 1 "$startdir/$i" | grep '^#!/bin/sh' >/dev/null ; then
414 415 416 417 418
				msg "Script found. busybox added as a dependency for $pkg"
				deps="$deps busybox"
				break
			fi
		done
419 420
	fi
	
Natanael Copa's avatar
Natanael Copa committed
421
	for i in $license; do
422
		echo "license = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
423 424
	done
	for i in $replaces; do
425
		echo "replaces = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
426
	done
427
	for i in $deps; do
428
		echo "depend = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
429 430
	done
	for i in $conflicts; do
431
		echo "conflict = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
432 433
	done
	for i in $provides; do
434
		echo "provides = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
435 436
	done
	for i in $backup; do
437
		echo "backup = $i" >> "$pkginfo"
Natanael Copa's avatar
Natanael Copa committed
438
	done
Natanael Copa's avatar
Natanael Copa committed
439 440 441
	if [ -n "$triggers" ]; then
		echo "triggers = ${triggers#*:}" >> "$pkginfo"
	fi
Natanael Copa's avatar
Natanael Copa committed
442 443

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
444
	for i in $install ${triggers%%:*}; do
445 446
		script=${i#$name}
		case "$script" in
Natanael Copa's avatar
Natanael Copa committed
447
			.pre-install|.post-install|.pre-upgrade|.post-upgrade|.pre-deinstall|.post-deinstall|.trigger)
448 449
				msg "Adding $script"
				;;
Natanael Copa's avatar
Natanael Copa committed
450
			*) 	error "$script: Invalid install/trigger script"
451 452 453
				return 1
				;;
		esac
Natanael Copa's avatar
Natanael Copa committed
454
		cp "$startdir/$i" "$controldir/$script" || return 1
455
		chmod +x "$controldir/$script"
456 457
		metafiles="$metafiles $script"
	done
458
	echo $metafiles | tr ' ' '\n' > "$controldir"/.metafiles
459
}
460

461 462 463
prepare_tracedeps() {
	local dir=${subpkgdir:-$pkgdir}
	options_has "!tracedeps" && return 0
464 465
	find -name '*.so' -o -name '*.so.[0-9]*' | sed 's:.*/::' \
		>"$controldir"/.provides-so
466
	scanelf -Rn "$dir" | tr ' ' ':' | awk -F ":" '$1 == "ET_DYN" || $1 == "ET_EXEC" {print $2}'  \
467 468 469
		| sed 's:,:\n:g' | sort | uniq \
	| while read i; do
		# only add files that are not self provided
470 471
		grep "^$i$" "$controldir"/.provides-so >/dev/null \
			|| echo $i >> "$controldir"/.needs-so
472
	done
Natanael Copa's avatar
Natanael Copa committed
473 474
}

475
prepare_package() {
476
	msg "Preparing ${subpkgname:+sub}package ${subpkgname:-$pkgname}..."
477
	stripbin
478
	prepare_metafiles && prepare_tracedeps
479 480 481 482 483 484 485 486
}

pkginfo_val() {
	local key="$1"
	local file="$2"
	awk -F ' = ' "\$1 == \"$key\" {print \$2}" "$file"
}

487 488 489
trace_apk_deps() {
	local name="$1"
	local dir="$2"
490 491
	local i j found autodeps=
	msg "Tracing dependencies for $name..."
492 493 494 495
	# add pkgconfig if usr/lib/pkgconfig is found
	if [ -d "$pkgbasedir"/$name/usr/lib/pkgconfig ] \
			&& ! grep -q '^depend = pkgconfig' "$dir"/.PKGINFO; then
		msg "Added pkgconfig as dependency"
496 497 498 499 500 501 502 503
		autodeps="$autodeps pkgconfig"
	fi

	# special case for libpthread: we need depend on libgcc
	if grep -q -w '^libpthread.so.*' "$dir"/.needs-so 2>/dev/null \
			&& ! grep -q -w "^depend = libgcc" "$dir"/.PKGINFO; then
		autodeps="$autodeps libgcc"
		msg "Added libgcc as dependency due to libpthread"
504
	fi
505
	for i in $(cat "$dir"/.needs-so 2>/dev/null); do
506
		found=
507
		# first check if its provide by same apkbuild
508
		for j in "$dir"/../.control.*/.provides-so; do
509
			grep -w "$i" "$j" >/dev/null || continue
510
			found=${j%/.provides-so}
511
			found=${found##*/.control.}
512
			break
513 514 515
		done
		# check apk db if not provided by a subpackage
		if [ -z "$found" ]; then
516
			found=$($APK info -q -W /lib/$i /usr/lib/$i)
517 518 519 520 521
		fi
		if [ -z "$found" ]; then
			error "Could not find dependency for $i"
			return 1
		fi
522
		if grep -w "^depend = ${found}$" "$dir"/.PKGINFO >/dev/null ; then
523 524 525
			warning "You can remove '$found' from depends"
			continue
		fi
526 527
		list_has "$found" $autodeps || autodeps="$autodeps $found"
		msg "Added '$found' as dependency as it has $i"
528
	done
529

530 531 532 533 534 535 536
	[ -z "$autodeps" ] && return 0
	echo "# automatically detected:" >> "$dir"/.PKGINFO
	for i in $autodeps; do
		echo "depend = $i" >> "$dir"/.PKGINFO
	done
}

537 538
create_apks() {
	local file
539
	getpkgver || return 1
540
	for file in "$pkgbasedir"/.control.*/.PKGINFO; do
541 542 543
		local dir="${file%/.PKGINFO}"
		local name=$(pkginfo_val pkgname $file)
		local ver=$(pkginfo_val pkgver $file)
544
		local apk=$name-$ver.apk
545
		local datadir="$pkgbasedir"/$name
546 547

		trace_apk_deps "$name" "$dir" || return 1
548
		msg "Creating $apk..."
549
		(
550 551
		cd "$datadir"
		# data.tar.gz
552 553 554 555 556 557
		set -- *
		if [ "$1" = '*' ]; then
			touch .dummy
			set -- .dummy
		fi
		tar -c "$@" | abuild-tar --hash | gzip -9 >"$dir"/data.tar.gz
558 559 560 561 562 563

		# append the hash for data.tar.gz
		local sha256=$(sha256sum "$dir"/data.tar.gz | cut -f1 -d' ')
		echo "datahash = $sha256" >> "$dir"/.PKGINFO

		# control.tar.gz
564
		cd "$dir"
565 566
		tar -c $(cat "$dir"/.metafiles) | abuild-tar --cut \
			| gzip -9 > control.tar.gz
567
		abuild-sign -q control.tar.gz || exit 1
Natanael Copa's avatar
Natanael Copa committed
568

569 570 571
		# create the final apk
		cat control.tar.gz data.tar.gz > "$PKGDEST"/$apk
	)
572 573 574
	done
}

575
update_abuildrepo() {
576
	if ! apk_up2date || [ -n "$force" ]; then
577
		sanitycheck && builddeps && clean && fetch && unpack \
Natanael Copa's avatar
Natanael Copa committed
578
			&& prepare && mkusers && rootpkg || return 1
579
	fi
580

581
	local apk
582 583
	mkdir -p "$abuildrepo" || return 1
	cd "$abuildrepo"
584 585 586 587 588 589 590 591 592

	# remove broken links
	for apk in *.apk; do
		if [ -L "$apk" ] && [ ! -f "$apk" ]; then
			rm -f "$apk"
		fi
	done

	# create links for this package
593
	for apk in $(listpkg); do
594
		ln -sf "$PKGDEST"/$apk "$abuildrepo"/$apk
595 596
	done

597
	msg "Updating the cached abuild repository index..."
598 599 600 601 602
	local sign=".SIGN.RSA.${SIGN_PUBLIC_KEY##*/}"
	local oldindex=
	if [ -f APKINDEX.tar.gz ]; then
		oldindex="--index APKINDEX.tar.gz"
	fi
603
	$APK index $oldindex --output APKINDEX.tar.gz.unsigned \
604 605
		--description "$repo $(cd $startdir && git describe)" \
		*.apk || exit 1
606 607 608
	msg "Signing the index..."
	abuild-sign -q APKINDEX.tar.gz.unsigned || exit 1
	mv APKINDEX.tar.gz.unsigned APKINDEX.tar.gz
Natanael Copa's avatar
Natanael Copa committed
609
	chmod 644 APKINDEX.tar.gz
610 611
}

612
# predefined splitfunc doc
613
default_doc() {
614
	depends="$depends_doc"
615
	install="$install_doc"
Natanael Copa's avatar
Natanael Copa committed
616
	triggers="$triggers_doc"
Natanael Copa's avatar
Natanael Copa committed
617
	local i
618
	for i in doc man info html sgml licenses gtk-doc; do
619 620 621
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
622 623
		fi
	done
624 625 626
	
	rm -f "$subpkgdir/usr/share/info/dir"

627 628 629
#	# compress info and man pages
#	find "$subpkgdir/usr/share" \( -name '*.info' -o -name '*.info-[1-9]' \
#		-o -name '*.[1-9]' \) -exec gzip {} \;
630 631 632 633

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

Natanael Copa's avatar
Natanael Copa committed
634
#	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
635 636 637
	return 0
}

638 639 640 641
doc() {
	default_doc
}

642
# predefined splitfunc mod
643
default_mod() {
644
	depends="$kernel $depends_mod"
645
	install="$install_mod"
Natanael Copa's avatar
Natanael Copa committed
646
	for i in firmware modules; do
647 648 649
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
650
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
651 652 653 654
		fi
	done
}

655 656 657 658
mod() {
	default_mod
}

659
# predefined splitfunc dev
660
default_dev() {
661
	local i= j=
662
	depends="$pkgname $depends_dev"
663
	install="$install_dev"
Natanael Copa's avatar
Natanael Copa committed
664
	triggers="$triggers_dev"
665 666 667 668
	for i in $origsubpackages; do
		[ "${i%:*}" = "$subpkgname" ] || depends="$depends ${i%:*}"
	done
		
669
	cd "$pkgdir" || return 0
670 671
	for i in usr/include usr/lib/pkgconfig usr/share/aclocal\
			usr/share/gettext usr/bin/*-config	\
672
			usr/share/vala/vapi usr/share/gir-[0-9]*\
673 674 675
			$(find -name include -type d) 		\
			$(find usr/ -name '*.[acho]' -o -name '*.la' \
			2>/dev/null); do
676 677
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
678
			mkdir -p "$d"
679
			mv "$pkgdir/$i" "$d"
680
			rmdir "$pkgdir/${i%/*}" 2>/dev/null
Natanael Copa's avatar
Natanael Copa committed
681 682
		fi
	done
683 684 685 686 687 688 689
	# move *.so links needed when linking the apps to -dev packages
	for i in lib/*.so usr/lib/*.so; do
		if [ -L "$i" ]; then
			mkdir -p "$subpkgdir"/"${i%/*}"
			mv "$i" "$subpkgdir/$i" || return 1
		fi
	done
Natanael Copa's avatar
Natanael Copa committed
690
	return 0
Natanael Copa's avatar
Natanael Copa committed
691 692
}

693 694 695 696
dev() {
	default_dev
}

697 698 699 700
is_function() {
	type "$1" 2>&1 | head -n 1 | egrep -q "is a (shell )?function"
}

Natanael Copa's avatar
Natanael Copa committed
701 702
# build and package in fakeroot
rootpkg() {
703 704 705 706
	local do_build=build
	cd "$startdir"
	if is_function package; then
		build || return 1
707
		do_build=package
708
	fi
Natanael Copa's avatar
Natanael Copa committed
709
	cd "$startdir"
710
	[ -n "$FAKEROOT" ] && msg "Entering fakeroot..."
711
	$FAKEROOT -- "$abuild_path" $color_opt $do_build \
712 713
		prepare_subpackages \
		prepare_package \
714
		create_apks
Natanael Copa's avatar
Natanael Copa committed
715 716 717
}

srcpkg() {
718
	getpkgver || return 1
719
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
720
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
721 722 723 724 725
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
726
	msg "Creating source package $p.src.tar.gz..."
727
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
728 729
}

730
# check if package is up to date
731
apk_up2date() {
732
	getpkgver || return 1
733
	local pkg="$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk"
734
	local i s
Natanael Copa's avatar
Natanael Copa committed
735
	cd "$startdir"
736 737 738 739 740
	for i in $pkgname $subpackages; do
		[ -f "$PKGDEST/$pkgname-$pkgver-r$pkgrel.apk" ] || return 1
	done
	[ -n "$keep" ] && return 0

741
	for i in $source APKBUILD; do
742 743 744 745 746 747
		local s
		if is_remote "$i"; then
			s="$SRCDEST/${i##*/}"	# $(basename $i)
		else
			s="$startdir/${i##*/}"
		fi
748 749 750 751 752 753 754
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

755
abuildindex_up2date() {
756
	local i apk
757
	getpkgver || return 1
758 759
	for i in $pkgname $subpackages; do
		apk="${i%:*}-$pkgver-r$pkgrel.apk"
760
		[ "$abuildrepo"/APKINDEX.tar.gz -nt "$abuildrepo"/$apk ] || return 1
761 762 763 764 765
	done
	return 0
}

up2date() {
766 767 768 769 770 771 772
	apk_up2date && abuildindex_up2date
}

# rebuild package and abuildrepo index if needed
abuildindex() {
	up2date && return 0
	update_abuildrepo
773 774
}

775 776 777 778 779 780 781
# source all APKBUILDs and output:
#  1) origin of package
#  2) all dependencies
# the output is i in a format easy parseable for awk
depparse_aports() {
	# lets run this in a subshell since we source all APKBUILD here
	(
782 783
	aportsdir=$(realpath ${APKBUILD%/APKBUILD}/..)
	for i in $aportsdir/*/APKBUILD; do
784 785 786 787
		pkgname=
		subpackages=
		depends=
		makedepends=
788
		. $i
789
		dir=${i%/APKBUILD}
790
		deps=
791
		# filter out conflicts from deps and version info
792 793 794 795
		for j in $depends $makedepends; do
			case "$j" in
				!*) continue;;
			esac
796
			deps="$deps ${j%%[<>=]*}"
797
		done
798
		for j in $pkgname $subpackages; do
799
			echo "o ${j%%:*} $dir"
800
			set -- $deps
801 802 803 804 805 806 807
			echo -n "d ${j%%:*} $1"
			shift
			while [ $# -gt 0 ]; do
				echo -n ",$1"
				shift
			done
			echo
808 809
		done
	done
810
	)
811 812
}

813
deptrace() {
814 815 816
	local deps= i=
	# strip versions from deps
	for i in "$@"; do
817
		deps="$deps ${i%%[<>=]*}"
818
	done
819
	[ -z "$deps" ] && return 0
820 821 822
	( 	depparse_aports 
		if [ -z "$upgrade" ]; then
			# list installed pkgs and prefix with 'i '
823
			$APK info -q | sort |  sed 's/^/i /'
824
		fi
825
	) | awk -v pkgs="$deps" '
826 827 828 829 830 831 832 833 834 835 836 837 838 839 840 841 842 843 844 845 846 847 848 849 850

	function depgraph(pkg,	a, i) {
		if (visited[pkg])
			return 0;
		visited[pkg] = 1;
		split(deps[pkg], a, ",");
		for (i in a)
			depgraph(a[i]);
		print pkg ":" origin[pkg];

	}

	$1 == "i" { visited[$2] = 1 }
	$1 == "o" { origin[$2] = $3 }
	$1 == "d" { deps[$2] = $3 }
	END {
		split(pkgs, pkgarray);
		for (i in pkgarray)
			depgraph(pkgarray[i]);
	}
	'
}

# build and install dependencies
builddeps() {
851
	local deps= alldeps= pkg= i= dir= ver= missing= installed_deps=
852
	local filtered_deps= conflicts=
853
	[ -n "$nodeps" ] && return 0
854
	msg "Analyzing dependencies..."
855

856 857 858
	# add depends unless it is a subpackage or package itself
	for i in $BUILD_BASE $depends $makedepends; do
		[ "$pkgname" = "${i%%[<>=]*}" ] && continue
859
		subpackages_has ${i%%[<>=]*} || deps="$deps $i"
860 861
	done

862
	installed_deps=$($APK info -e $deps)
863
	# find which deps are missing
864
	for i in $deps; do
865
		if [ "${i#\!}" != "$i" ]; then
866
			$APK info -q -e "${i#\!}" \
867
				&& conflicts="$conflicts ${i#\!}"
868
		elif ! deplist_has $i $installed_deps || [ -n "$upgrade" ]; then
869 870 871
			missing="$missing $i"
		fi
	done
872
	
873
	if [ -n "$conflicts" ]; then
874 875
		error "Conflicting package(s) installed:$conflicts"
		return 1
876 877 878 879 880 881 882 883
	fi
	
	if [ -z "$install_deps" ] && [ -z "$recursive" ]; then
		# if we dont have any missing deps we are done now
		[ -z "$missing" ] && return 0
		error "Missing dependencies: $missing Use -r to autoinstall or -R to build"
		return 1
	fi
884

885
	uninstall_after=".makedepends-$pkgname $uninstall_after"
886
	if [ -n "$install_deps" ] && [ -z "$recursive" ]; then
887 888
		# make a --simluate run first to detect missing deps
		# apk-tools --virtual is no goot at reporting those.
889
		$SUDO $APK add --repository "$abuildrepo" \
890 891
			--wait 30 \
			--simulate --quiet $deps || return 1
892
		$SUDO $APK add --repository "$abuildrepo" \
893
			--wait 30 \
894 895
			--virtual .makedepends-$pkgname $deps \
			&& return 0
896
	fi
897 898
	
	[ -z "$recursive" ] && return 1
899 900 901

	# find dependencies that are installed but missing in repo.
	for i in $deps; do
902
		local m=$($APK search --repository "$abuildrepo" ${i%%[<>=]*})
Natanael Copa's avatar
Natanael Copa committed
903
		if [ -z "$m" ]; then
904 905 906
			missing="$missing $i"
		fi
	done
907 908
	
	for i in $(deptrace $missing); do
909 910 911
		# i = pkg:dir
		local dir=${i#*:}
		local pkg=${i%:*}
912 913 914 915 916 917 918 919 920 921

		# ignore if dependency is in other repo
		[ -d "$dir" ] || continue
		
		# break cricular deps
		list_has $pkg $ABUILD_VISITED && continue
		export ABUILD_VISITED="$ABUILD_VISITED $pkg"

		msg "Entering $dir"
		cd "$dir" && $0 $forceroot $keep $quiet $install_deps \
922
			$recursive $upgrade $color_opt abuildindex || return 1
923
	done
924
	$SUDO $APK add -u --repository "$abuildrepo" \
925
		--wait 30 \
926
		--virtual .makedepends-$pkgname $deps
927 928
}

929
# replace the md5sums in the APKBUILD
Natanael Copa's avatar
Natanael Copa committed
930 931
checksum() {
	local s files
932
	[ -z "$source" ] && return 0
Natanael Copa's avatar
Natanael Copa committed
933
	fetch
934
	msg "Updating the md5sums in APKBUILD..."
Natanael Copa's avatar
Natanael Copa committed
935 936 937 938
	for s in $source; do
		files="$files ${s##*/}"
	done
	md5sums="$(cd "$srcdir" && md5sum $files)" || die "md5sum failed"
939 940
	sed -i -e '/^md5sums="/,/"\$/d; /^md5sums=''/,/''\$/d' "$APKBUILD"
	echo "md5sums=\"$md5sums\"" >>"$APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
941 942
}

943
stripbin() {
944
	local bin
945
	options_has "!strip" && return 0
946 947
	cd "${subpkgdir:-$pkgdir}" || return 1
	msg "Stripping binaries"
948 949 950
	scanelf --recursive --nobanner --etype "ET_DYN,ET_EXEC" . \
		| sed -e 's:^ET_DYN ::' -e 's:^ET_EXEC ::' \
		| xargs -r strip
951 952
}

953 954 955
# simply list target apks
listpkg() {
	local i 
956
	getpkgver || return 1
957 958 959 960 961
	for i in $pkgname $subpackages; do
		echo "${i%:*}-$pkgver-r$pkgrel.apk"
	done
}

Natanael Copa's avatar
Natanael Copa committed
962 963 964 965 966 967 968 969
source_has() {
	local i
	for i in $source; do
		[ "$1" = "${i##*/}" ] && return 0
	done
	return 1
}

Natanael Copa's avatar
Natanael Copa committed
970 971 972 973 974 975 976 977
subpackages_has() {
	local i
	for i in $subpackages; do
		[ "$1" = "${i%:*}" ] && return 0
	done
	return 1
}

978 979 980 981 982 983 984 985 986 987 988
list_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

989 990 991 992 993 994
# same as list_has but we filter version info
deplist_has() {
	local needle="$1"
	local i
	shift
	for i in $@; do
995
		i=${i%%[<>=]*}
996 997 998 999 1000 1001
		[ "$needle" = "$i" ] && return 0
		[ "$needle" = "!$i" ] && return 1
	done
	return 1
}

1002 1003 1004 1005
options_has() {
	list_has "$1" $options
}

1006
depends_has() {
1007
	deplist_has "$1" $depends
1008 1009
}

1010
makedepends_has() {
1011
	deplist_has "$1" $makedepends
1012 1013
}

Natanael Copa's avatar
Natanael Copa committed
1014 1015 1016 1017
md5sums_has() {
	list_has "$1" $md5sums
}

Natanael Copa's avatar
Natanael Copa committed
1018 1019 1020 1021
install_has() {
	list_has "$1" $install
}

Natanael Copa's avatar
Natanael Copa committed
1022 1023
# install package after build
post_add() {
1024
	getpkgver || return 1
Natanael Copa's avatar
Natanael Copa committed
1025 1026 1027 1028 1029 1030
	local pkgf="$PKGDEST/$1-$pkgver-r$pkgrel.apk"
	local deps i
	if ! subpackages_has $1 && [ "$1" != "$pkgname" ]; then
		die "$1 is not built by this APKBUILD"
	fi
	# recursively install dependencies that are provided by this APKBUILD
1031
	deps=$($APK index "$pkgf" 2>/dev/null | awk -F: '$1=="D" { print $2 }')
Natanael Copa's avatar
Natanael Copa committed
1032 1033 1034 1035 1036
	for i in $deps; do
		if subpackages_has $i || [ "$i" = "$pkgname" ]; then
			post_add $i || return 1
		fi
	done
1037
	$SUDO $APK add --wait 30 -u "$pkgf" || die "Failed to install $1"
Natanael Copa's avatar
Natanael Copa committed
1038 1039
}

1040
installdeps() {
1041
	local deps i
1042
	sudo $APK add --wait 30 --repository "$abuildrepo" \
1043
		--virtual .makedepends-$pkgname \
1044
		$makedepends
1045 1046 1047
}

uninstalldeps (){
1048
	sudo $APK del .makedepends-$pkgname
1049
}
1050 1051 1052 1053 1054

all() {
	if up2date && [ -z "$force" ]; then
		msg "Package is up to date"
	else
1055
		update_abuildrepo
1056 1057 1058
	fi
}

Natanael Copa's avatar
Natanael Copa committed
1059
usage() {
1060 1061
	echo "$program $abuild_ver"
	echo "usage: $program [options] [-i PKG] [-P REPODEST] [-p PKGDEST]"
1062
	echo "              [-s SRCDEST] [cmd] ..."
1063
	echo "       $program [-c] -n PKGNAME[-PKGVER]"
Natanael Copa's avatar
Natanael Copa committed
1064
	echo "Options:"
1065
	echo " -c  Enable colored output"
1066
	echo " -d  Disable dependency checking"
Natanael Copa's avatar
Natanael Copa committed
1067
	echo " -f  Force specified cmd, even if they are already done"
1068
	echo " -F  Force run as root"
1069 1070
	echo " -h  Show this help"
	echo " -i  Install PKG after successul build"
1071
	echo " -k  Keep built packages, even if APKBUILD or sources are newer"
1072
	echo " -m  Disable colors (monochrome)"
1073
	echo " -p  Set package destination directory"
1074
	echo " -P  Set PKGDEST to REPODEST/<repo>, where repo is the parents dir name" 
Natanael Copa's avatar
Natanael Copa committed
1075
	echo " -q  Quiet"
1076 1077
	echo " -r  Install missing dependencies from system repository (using sudo)"
	echo " -R  Recursively build and install missing dependencies (using sudo)"
1078
	echo " -s  Set source package destination directory"
1079
	echo " -u  Recursively build and upgrade all dependencies (using sudo)"
Natanael Copa's avatar
Natanael Copa committed
1080 1081
	echo ""
	echo "Commands:"
1082
	echo "  checksum    Generate checksum to be included in APKBUILD"
1083 1084 1085 1086 1087
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$